#ifndef _NEWPASSDLG_CPP
#define _NEWPASSDLG_CPP
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <ShlObj.H>
#include <Stdio.H>
#include <ShlOBJ.H>
#include <Stdlib.H>

#include "../Resources/Resource.H"

#include "../Source/NSWFL.H"
#include "../Source/Package.H"
#include "../Source/Entry.H"
#include "../Source/Common.H"
#include "../Source/FolderTree.H"

#include "../Dialogs/MainDlg.H"
#include "../Dialogs/NewPassDlg.H"
#include "../Dialogs/OpenPassDlg.H"
#include "../Dialogs/NewFolderDlg.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//---------------------(Variable Declarations)
HWND NewPassDialog_hWnd = NULL;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CALLBACK NewPassDialog(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    //--------------------------------------------------------------------------

    static FolderTree MyFolderTree;

    static HWND BrowseTree_hWnd = NULL;
    static HWND Password1_hWnd = NULL;
    static HWND Password2_hWnd = NULL;
    static HWND PasswordBits_hWnd = NULL;
    static HWND PasswordBitsBar_hWnd = NULL;
    static HWND SaveToLocation_hWnd = NULL;
    static HWND SaveToFile_hWnd = NULL;
    static HWND CompressLevel_hWnd = NULL;
    static HWND EncryptAlgo_hWnd = NULL;

    //--------------------------------------------------------------------------

    if(uMsg == WM_INITDIALOG) // Received A Initilize Dialog Message
    {
        NewPassDialog_hWnd = hWnd;

		char sDfltStr[1024];
		DWORD dwDfltStrSz = 0;

		HMENU hSysMenu = GetSystemMenu(hWnd, FALSE);
        AppendMenu(hSysMenu, MF_SEPARATOR, 0, 0);
        AppendMenu(hSysMenu, MF_STRING, 1000, "About");

        SendMessage(hWnd, (UINT)WM_SETTEXT, (WPARAM)0, (LPARAM)gsTitleCaption);
        SendMessage(hWnd, WM_SETICON, TRUE, (LPARAM) LoadIcon(ghAppInstance, MAKEINTRESOURCE(IDI_MAIN)) );

        Password1_hWnd = GetDlgItem(hWnd, IDC_PASSWORD1);
        Password2_hWnd = GetDlgItem(hWnd, IDC_PASSWORD2);
        PasswordBitsBar_hWnd = GetDlgItem(hWnd, IDC_PASSWORDBAR2);
        PasswordBits_hWnd = GetDlgItem(hWnd, IDC_PASSWORDBITS2);
        SaveToLocation_hWnd = GetDlgItem(hWnd, IDC_SAVETOLOCATION);
        SaveToFile_hWnd = GetDlgItem(hWnd, IDC_SAVETOFILE);
        CompressLevel_hWnd = GetDlgItem(hWnd, IDC_COMPRESSLEVEL);
        EncryptAlgo_hWnd = GetDlgItem(hWnd, IDC_ENCRYPTALGO);
        BrowseTree_hWnd = GetDlgItem(hWnd, IDC_BROWSETREE);

		SendMessage(Password1_hWnd, EM_LIMITTEXT, 1024, 0 );
        SendMessage(Password2_hWnd, EM_LIMITTEXT, 1024, 0 );

        int iIndex = 0;

		//-----------------------------------------------------------------------------------------
        SendMessage(CompressLevel_hWnd, (UINT)CB_ADDSTRING, (WPARAM)0, (LPARAM)"None");
        SendMessage(CompressLevel_hWnd, (UINT)CB_ADDSTRING, (WPARAM)0, (LPARAM)"Very Low (Default)");
        SendMessage(CompressLevel_hWnd, (UINT)CB_ADDSTRING, (WPARAM)0, (LPARAM)"Low");
        SendMessage(CompressLevel_hWnd, (UINT)CB_ADDSTRING, (WPARAM)0, (LPARAM)"Moderate");
        SendMessage(CompressLevel_hWnd, (UINT)CB_ADDSTRING, (WPARAM)0, (LPARAM)"High");
        SendMessage(CompressLevel_hWnd, (UINT)CB_ADDSTRING, (WPARAM)0, (LPARAM)"Very High (Slowest)");

   	    //Set the default Compression Method.
		dwDfltStrSz = sizeof(sDfltStr);
		memset(sDfltStr, 0, dwDfltStrSz);
		if(Get_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "MainDlg.DfltCompressLevel", sDfltStr, dwDfltStrSz))
			iIndex = SendMessage(CompressLevel_hWnd, (UINT)CB_FINDSTRING, (WPARAM)-1, (LPARAM) sDfltStr);
		else iIndex = SendMessage(CompressLevel_hWnd, (UINT)CB_FINDSTRING, (WPARAM)-1, (LPARAM) "None");
		SendMessage(CompressLevel_hWnd, (UINT)CB_SETCURSEL, (WPARAM)iIndex, (LPARAM)NULL);

		//-----------------------------------------------------------------------------------------
        SendMessage(EncryptAlgo_hWnd, (UINT)CB_ADDSTRING, (WPARAM)0, (LPARAM)"AES Algorithm (Rijndael)");
        SendMessage(EncryptAlgo_hWnd, (UINT)CB_ADDSTRING, (WPARAM)0, (LPARAM)"NASCCL");
        SendMessage(EncryptAlgo_hWnd, (UINT)CB_ADDSTRING, (WPARAM)0, (LPARAM)"BlowFish");
        SendMessage(EncryptAlgo_hWnd, (UINT)CB_ADDSTRING, (WPARAM)0, (LPARAM)"Simple Cipher");

	    //Set the default Encryption Algorithm.
		dwDfltStrSz = sizeof(sDfltStr);
		memset(sDfltStr, 0, dwDfltStrSz);
		if(Get_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "MainDlg.DfltEncryptAlgo", sDfltStr, dwDfltStrSz))
			iIndex = SendMessage(EncryptAlgo_hWnd, (UINT)CB_FINDSTRING, (WPARAM)-1, (LPARAM) sDfltStr);
		else iIndex = SendMessage(EncryptAlgo_hWnd, (UINT)CB_FINDSTRING, (WPARAM)-1, (LPARAM) "Simple Cipher");
		SendMessage(EncryptAlgo_hWnd, (UINT)CB_SETCURSEL, (WPARAM)iIndex, (LPARAM)NULL);

		//-----------------------------------------------------------------------------------------
		if(Get_BOOLRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "MainDlg.ChkTimeStamps"))
		{
			CheckDlgButton(hWnd, IDC_CHKTIMESTAMPS, BST_CHECKED);
		}
		else CheckDlgButton(hWnd, IDC_CHKTIMESTAMPS, BST_CHECKED);

		//-----------------------------------------------------------------------------------------
		if(Get_BOOLRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "MainDlg.ChkAttributes"))
		{
	        CheckDlgButton(hWnd, IDC_CHKATTRIBUTES, BST_CHECKED);
		}
		else CheckDlgButton(hWnd, IDC_CHKATTRIBUTES, BST_CHECKED);

		//-----------------------------------------------------------------------------------------
		if(Get_BOOLRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "MainDlg.ChkCRCs"))
		{
	        CheckDlgButton(hWnd, IDC_CHKCRCS, BST_CHECKED);
		}
		else CheckDlgButton(hWnd, IDC_CHKCRCS, BST_CHECKED);

		//-----------------------------------------------------------------------------------------
        if(gdwCurrentJobType == JOB_TYPE_PACKING_FIL)
		{
			CheckDlgButton(hWnd, IDC_CHKSAVEPATHS, BST_UNCHECKED);
			EnableWindow(GetDlgItem(hWnd, IDC_CHKSAVEPATHS), FALSE);
		}
		else{
			if(Get_BOOLRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "MainDlg.ChkSavePaths"))
			{
				CheckDlgButton(hWnd, IDC_CHKSAVEPATHS, BST_CHECKED);
			}
			else CheckDlgButton(hWnd, IDC_CHKSAVEPATHS, BST_CHECKED);
		}

		//-----------------------------------------------------------------------------------------
        Set_Text(Password1_hWnd, gsPassword);
        Set_Text(Password2_hWnd, gsPassword);

        Set_Text(Password1_hWnd, "11111111");
        Set_Text(Password2_hWnd, "11111111");

		MyFolderTree.InitFolderTree(BrowseTree_hWnd, GetDlgItem(hWnd, IDC_ENCRYPT), SaveToLocation_hWnd);

		char FullPath[MAX_PATH + 1];
        char sDrive[MAX_PATH + 1];
        char sDir[MAX_PATH + 1];
        char sFile[MAX_PATH + 1];
        char sExt[MAX_PATH + 1];

		if(strlen(gsWorkingOutput) > 0)
		{
			strcpy_s(gsArchiveName, sizeof(gsArchiveName), gsWorkingOutput);
		}

		if(strlen(gsArchiveName) == 0)
		{
			if(MyFolderTree.GetDesktopFolderPath(gsArchiveName))
			{
				MyFolderTree.SelectPath(gsArchiveName);
			}

			strcat_s(gsArchiveName, sizeof(gsArchiveName), "\\New Archive.pce");
		}

		if(IsDirectory(gsArchiveName))
        {
            int iLength = strlen(gsArchiveName);

            if(gsArchiveName[iLength - 1] == '\\')
            {
                gsArchiveName[iLength] = '\0';
            }

            _splitpath_s(gsArchiveName,
				sDrive, sizeof(sDrive),
				sDir, sizeof(sDir),
				sFile, sizeof(sFile),
				sExt, sizeof(sExt));
            
			//Append the file extension to the file name.
			//	Just incase the directory has a period (.) in its name.
			strcat_s(sFile, sizeof(sFile), sExt);
			
			_makepath_s(FullPath, sizeof(FullPath), sDrive, sDir, NULL, NULL);
            MyFolderTree.SelectPath(FullPath);

            _makepath_s(FullPath, sizeof(FullPath), NULL, NULL, sFile, ".pce");
            Set_Text(SaveToFile_hWnd, FullPath);
        }
        else {
            // Parse sFile name and location
            _splitpath_s(gsArchiveName,
				sDrive, sizeof(sDrive),
				sDir, sizeof(sDir),
				sFile, sizeof(sFile),
				NULL, 0);

            _makepath_s(FullPath, sizeof(FullPath), sDrive, sDir, NULL, NULL);
            MyFolderTree.SelectPath(FullPath);

			_makepath_s(FullPath, sizeof(FullPath), NULL, NULL, sFile, ".pce");
            Set_Text(SaveToFile_hWnd, FullPath);
        }

        CenterWindow(hWnd);

        return TRUE; // Return TRUE to set the keyboard focus, Otherwise return FALSE
    }

    //--------------------------------------------------------------------------

    if(MyFolderTree.FolderTreeHandler(hWnd, uMsg, wParam, lParam))
    {
        return TRUE;
    }

    //--------------------------------------------------------------------------

    if(uMsg == 307) // Key Down
    {
        float PasswordLen1   = 0;
        float PasswordLen2    = 0;
        float EffeciencyBits = 0;

        char lsTemp0[64];
        char lsTemp1[64];

        PasswordLen1 = (float) SendMessage(Password1_hWnd, WM_GETTEXTLENGTH, 0, 0);
        PasswordLen2 = (float) SendMessage(Password2_hWnd, WM_GETTEXTLENGTH, 0, 0);

        HWND CurrentFocus = GetFocus();

        if(CurrentFocus == Password1_hWnd)
        {
            EffeciencyBits = (PasswordLen1 / 56) * 100;
            SendMessage(PasswordBitsBar_hWnd, PBM_SETPOS, (int) EffeciencyBits, 0);

            sprintf_s(lsTemp0, sizeof(lsTemp0), " (%s Bits)", FormatInteger(lsTemp1, ((long)PasswordLen1 * 8)));
            Set_Text(PasswordBits_hWnd, lsTemp0);
        }
        else if(CurrentFocus == Password2_hWnd)
        {
            EffeciencyBits = (PasswordLen2 / 56) * 100;
            SendMessage(PasswordBitsBar_hWnd, PBM_SETPOS, (int) EffeciencyBits, 0);

            sprintf_s(lsTemp0, sizeof(lsTemp0), " (%s Bits)", FormatInteger(lsTemp1, ((long)PasswordLen2 * 8)));
            Set_Text(PasswordBits_hWnd, lsTemp0);
        }
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_COMMAND)
    {
		if(wParam == IDC_CMDHELP)
        {
			MsgBox("Not Implemented.");
			return TRUE;
		}

		if(wParam == IDC_NEWFOLDER)
        {
            int iLength = Get_TextEx(SaveToLocation_hWnd, gsExtractLocation, 255);
			if(iLength > 0 || iLength <= 255)
			{
				if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_NEWFOLDER), hWnd, NewFolderDialog) == 1)
				{
					char sNewPath[MAX_PATH + 1];
					_makepath_s(sNewPath, sizeof(sNewPath), NULL, gsExtractLocation, sNewFolderName, NULL);
					strcat_s(sNewPath, sizeof(sNewPath), "\\");
					CustomCreateFolderStructure(sNewPath);

					//This is a bad way to refresh the treview.
					MyFolderTree.UnInitFolderTree();
					MyFolderTree.InitFolderTree(BrowseTree_hWnd, GetDlgItem(hWnd, IDC_EXTRACT), SaveToLocation_hWnd);
					MyFolderTree.SelectPath(sNewPath);
				}
			}
			return TRUE;
		}

		if(wParam == IDC_GOTO)
        {
            int iLength = Get_TextEx(SaveToLocation_hWnd, gsExtractLocation, 255);
			if(iLength > 0 || iLength <= 255)
			{
				MyFolderTree.SelectPath(gsExtractLocation);
			}
			return TRUE;
		}

		if(wParam == IDC_ADVANCED)
        {
			int iHideShow = 0;
			char sAdvancedCap[25];

			HWND hButton = GetDlgItem(hWnd, IDC_ADVANCED);

			Get_TextEx(hButton, sAdvancedCap, sizeof(sAdvancedCap));
			
			if(_strcmpi(sAdvancedCap, "Advanced >>") == 0)
			{
				iHideShow = SW_SHOW;
				Set_Text(hButton, "Advanced <<");
			}
			else{
				iHideShow = SW_HIDE;
				Set_Text(hButton, "Advanced >>");			
			}

			ShowWindow(GetDlgItem(hWnd, IDC_ADVANCEDFRAME), iHideShow);
			ShowWindow(GetDlgItem(hWnd, IDC_CHKTIMESTAMPS), iHideShow);
			ShowWindow(GetDlgItem(hWnd, IDC_CHKATTRIBUTES), iHideShow);
			ShowWindow(GetDlgItem(hWnd, IDC_CHKCRCS), iHideShow);
			ShowWindow(GetDlgItem(hWnd, IDC_CHKSAVEPATHS), iHideShow);

			return TRUE;
		}

		if(wParam == IDC_ENCRYPT)
        {

            char lsPassword1[1024 + 1];
            char lsPassword2[1024 + 1];
            char lsCompressLevel[32 + 1];
			char lsEncryptionMethod[32 + 1];

            int Length1 = Get_TextEx(Password1_hWnd, lsPassword1, sizeof(lsPassword1));
            int Length2 = Get_TextEx(Password2_hWnd, lsPassword2, sizeof(lsPassword2));

            if((Length1 < 8 || Length1 > sizeof(lsPassword1)) || (Length2 < 8 || Length2 > sizeof(lsPassword2)))
            {
                MessageBox(hWnd, "Please enter the same password twice. Within 8 and 1,024 characters.", gsTitleCaption, 0);
                return TRUE;
            }

            if(strcmp(lsPassword1, lsPassword2) != 0)
            {
                MessageBox(hWnd, "The passwords you entered do not match.", gsTitleCaption, 0);
                return TRUE;
            }

            char sSaveToLocation[MAX_PATH + 1];
            char sSaveToFile[MAX_PATH + 1];

            Length1 = Get_TextEx(SaveToLocation_hWnd, sSaveToLocation, MAX_PATH);
            Length2 = Get_TextEx(SaveToFile_hWnd, sSaveToFile, MAX_PATH);

            if(sSaveToFile[0] == '\\' || sSaveToFile[0] == '/')
            {
                int Len = strlen(sSaveToLocation);
                if(sSaveToLocation[Len - 1] == '\\' || sSaveToLocation[Len - 1] == '/')
                {
                    sSaveToLocation[Len - 1] = '\0';
                }
                strcat_s(sSaveToLocation, sizeof(sSaveToLocation), sSaveToFile);
            }
            else{
                int Len = strlen(sSaveToLocation);
                if(sSaveToLocation[Len - 1] != '\\' && sSaveToLocation[Len - 1] != '/')
                {
                    strcat_s(sSaveToLocation, sizeof(sSaveToLocation), "\\");;
                }
                strcat_s(sSaveToLocation, sizeof(sSaveToLocation), sSaveToFile);
            }

			if(FileAccess(sSaveToLocation, FExist))
			{
				if(MessageBox(hWnd, "The File you have selected already exist. Would you like to overwrite it?", gsTitleCaption, MB_YESNO | MB_ICONQUESTION | MB_DEFBUTTON2) != IDYES)
				{
					return FALSE;
				}
			}

			strcpy_s(gsPassword, sizeof(gsPassword), lsPassword1);
            strcpy_s(gsWorkingOutput, sizeof(gsWorkingOutput), sSaveToLocation);

            giPkgAttribs = 0;

			//-----------------------------------------------------------------------------------------
            Get_TextEx(CompressLevel_hWnd, lsCompressLevel, 32);
            if(_strcmpi(lsCompressLevel, "none") != 0)
            {
                giPkgAttribs = giPkgAttribs | ATTRIB_COMPRESSION;
                if(_strcmpi(lsCompressLevel, "Very Low (Default)") == 0)
                    giCompressLevel = 0;
                else if(_strcmpi(lsCompressLevel, "Low") == 0)
                    giCompressLevel = 1;
                else if(_strcmpi(lsCompressLevel, "Moderate") == 0)
                    giCompressLevel = 2;
                else if(_strcmpi(lsCompressLevel, "High") == 0)
                    giCompressLevel = 3;
                else if(_strcmpi(lsCompressLevel, "Very High (Slowest)") == 0)
                    giCompressLevel = 4;
            }

			//-----------------------------------------------------------------------------------------
            Get_TextEx(EncryptAlgo_hWnd, lsEncryptionMethod, 32);
			if(_strcmpi(lsEncryptionMethod, "none") != 0)
            {
                if(_strcmpi(lsEncryptionMethod, "NASCCL") == 0)
				{
                    giCryptAlgo = CRYPT_ALGO_NASCCL;
				}
				else if(_strcmpi(lsEncryptionMethod, "AES Algorithm (Rijndael)") == 0){

                    giCryptAlgo = CRYPT_ALGO_RIJNDAEL;
				}
				else if(_strcmpi(lsEncryptionMethod, "BlowFish") == 0){
                    giCryptAlgo = CRYPT_ALGO_BLOWFISH;
				}
				else if(_strcmpi(lsEncryptionMethod, "Simple Cipher") == 0){
                    giCryptAlgo = CRYPT_ALGO_SIMPLE;
				}
            }

			//-----------------------------------------------------------------------------------------
			if(IsDlgButtonChecked(hWnd, IDC_CHKTIMESTAMPS))
			{
				Set_BOOLRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "MainDlg.ChkTimeStamps", true);
                giPkgAttribs = giPkgAttribs | ATTRIB_DATETIME;
			}
			else Set_BOOLRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "MainDlg.ChkTimeStamps", false);

			//-----------------------------------------------------------------------------------------
            if(IsDlgButtonChecked(hWnd, IDC_CHKATTRIBUTES))
			{
				Set_BOOLRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "MainDlg.ChkAttributes", true);
				giPkgAttribs = giPkgAttribs | ATTRIB_ATTRIBUTES;
			}
			else Set_BOOLRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "MainDlg.ChkAttributes", false);

    		//-----------------------------------------------------------------------------------------
	        if(IsDlgButtonChecked(hWnd, IDC_CHKCRCS))
			{
				giPkgAttribs = giPkgAttribs | ATTRIB_CRCCHECK;
				Set_BOOLRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "MainDlg.ChkCRCs", true);
			}
			else Set_BOOLRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "MainDlg.ChkCRCs", false);

			//-----------------------------------------------------------------------------------------
            if(IsDlgButtonChecked(hWnd, IDC_CHKSAVEPATHS))
			{
				giPkgAttribs = giPkgAttribs | ATTRIB_SAVEPATHS;

				if(gdwCurrentJobType != JOB_TYPE_PACKING_FIL)
				{
					Set_BOOLRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "MainDlg.ChkSavePaths", true);
				}
			}
			else if(gdwCurrentJobType != JOB_TYPE_PACKING_FIL)
			{
				Set_BOOLRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "MainDlg.ChkSavePaths", false);
			}

			//-----------------------------------------------------------------------------------------

		    //Save the default values to the registry.
			Set_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "MainDlg.DfltCompressLevel", lsCompressLevel);
			Set_StringRegistryValue(HKEY_LOCAL_MACHINE, gsRegistryKey, "MainDlg.DfltEncryptAlgo", lsEncryptionMethod);

			MyFolderTree.UnInitFolderTree();
            EndDialog(hWnd, 1);

			return TRUE;
        }

        if(wParam == IDC_CANCEL)
        {
            MyFolderTree.UnInitFolderTree();
        	EndDialog(hWnd, 0);
            return TRUE;
        }

        return FALSE;
    }

    //--------------------------------------------------------------------------

	if(uMsg == WM_PAINT)
    {
        HDC ThisHDC;
        PAINTSTRUCT ThisPS;

        ThisHDC = BeginPaint(hWnd, &ThisPS);

        // Any painting should be done here

        EndPaint(hWnd, &ThisPS);
        return TRUE;
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_SYSCOMMAND) // Received A System Menu Message
    {
        if(LOWORD(wParam) == 1000) //- About (SysMenu Command)
        {
            _AboutDialogInfo ADI;
    
            ADI.DisplayIcon  = LoadIcon(ghAppInstance, MAKEINTRESOURCE(IDI_MAIN));
            ADI.TitleCaption = gsTitleCaption;
            ADI.FileVersion  = gsFileVersion;
            ADI.BuildDate    = __DATE__;
            ADI.BuildTime    = __TIME__;
            ADI.CopyRight    = gsAppCopyRight;
            ADI.OwnerHandle  = hWnd;

            NetLogo(&ADI);
            return TRUE;
        }

        return FALSE;
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_CLOSE)  // Received Close Message
    {
        EndDialog(hWnd, 0);
        MyFolderTree.UnInitFolderTree();
        return TRUE;
    }

    //--------------------------------------------------------------------------

    return FALSE;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif

