#ifndef _CommonDialog_CPP
#define _CommonDialog_CPP
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <ShlObj.H>
#include <Stdio.H>
#include <ShlOBJ.H>
#include <Stdlib.H>

#include "../Resources/Resource.H"

#include "../Modules/NASCCL/NASCCL.H"
#include "../Modules/CRegCode/CRegCode.H"

#include "NSWFL.H"
#include "Package.H"
#include "Entry.H"
#include "Common.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

char gsExtractLocation[255 + 1];

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CustomCreateFolderStructure(char *sFullFileName)
{
    char sDir[256];

    int iNameSz = strlen(sFullFileName);
    int iPos = 0;

    while(iPos < iNameSz)
    {
        if(sFullFileName[iPos] == '\\' || sFullFileName[iPos] == '/')
        {
            sDir[iPos] = '\0';
            CreateDirectory(sDir, NULL);
        }

        sDir[iPos] = sFullFileName[iPos];

        iPos++;
    }
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool ValidateRegCode(unsigned char *sRegCode)
{
	//ValidateRegCode((unsigned char *)"DA4F5-3EE5E-BFD0B-3E6D1");

	CRegCode MyRegCode;
	
	int iRegCodeSeed = REG_CODE_KEY_SEEDI;

	//MyRegCode.GenRegCodes((unsigned char *)REG_CODE_KEY_SEEDS, &iRegCodeSeed, 100000, 10, 5, "C:\\RegCodes.txt");

	return MyRegCode.CheckRegCode((unsigned char *)REG_CODE_KEY_SEEDS, &iRegCodeSeed, 100000, 10, sRegCode);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void FixDirTarget(char *sPath, int iMaxSz)
{
	int iLen = strlen(sPath);

	if(sPath[iLen - 1] != '\0')
	{
		strcat_s(sPath, iMaxSz, "\\");
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void SetStatusFileName(HWND hWnd, char *StatusText)
{
    char LocalBuffer[60 + 1];

    int iLength = strlen(StatusText);
    int iRPos = 0;
    int iWPos = 0;
    int MinPos = (iLength - 60);

    if(iLength <= 60)
    {
        Set_Text(hWnd, StatusText);
        return;
    }

    iRPos = iLength;

    while(iRPos != MinPos)
    {
        if(StatusText[iRPos] == '\\')
            break;

        iRPos--;
    }

    while(iRPos < iLength)
    {
        LocalBuffer[iWPos] = StatusText[iRPos];
        iRPos++;
        iWPos++;
    }

    LocalBuffer[iWPos] = '\0';

    Set_Text(hWnd, LocalBuffer);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

long Reflect_Checksum(long lReflect, char cChar)
{
	long Value = 0;

	// Swap Bit 0 For Bit 7 Bit 1 For Bit 6, Etc....
	for(int Loop = 1; Loop < (cChar + 1); Loop++)
	{
		if(lReflect & 1)
        {
            Value |= 1 << (cChar - Loop);
        }

		lReflect >>= 1;
	}

	return Value;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

long MakeChecksum(char *sRawKey)
{
    char sKeyHash[CHECKSUMLEN + 1];
    int iRPos = 0;
    long lChecksum = 0;

    HashKey(sRawKey, sKeyHash, strlen(sRawKey), CHECKSUMLEN);

	while(iRPos < CHECKSUMLEN)
    {
        lChecksum = (lChecksum + sKeyHash[iRPos]) + Reflect_Checksum(lChecksum, sKeyHash[iRPos]);
        iRPos++;
    }

    return lChecksum;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool GetLastDirectoryInPath(char *inFullPath, char *outLastDir)
{
    int iRPos = (strlen(inFullPath) - 1);
    int iWPos = 0;

    if(iRPos <= 0)
    {
        outLastDir[0] = '\0';
        return false;
    }

    if(inFullPath[iRPos] == '\\' || inFullPath[iRPos] == '//')
    {
        iRPos--;
    }

    if(inFullPath[iRPos] != ':' && inFullPath[iRPos-1] != ':')
    {
        while(iRPos != 0 && inFullPath[iRPos] != '\\' && inFullPath[iRPos] != '//')
        {
            outLastDir[iWPos] = inFullPath[iRPos];
            iRPos--;
            iWPos++;
        }

        outLastDir[iWPos++] = '\\';
        outLastDir[iWPos] = '\0';
        ReverseString(outLastDir, iWPos);
    }
    else{
        outLastDir[0] = '\0';
        return false;
    }

    return true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void AllocIconList(LPDBGICONLIST lpMyIconList, int ExtLen, int DescrLen)
{
    lpMyIconList->sExt = (char *) calloc(sizeof(char), ExtLen + 1);
    lpMyIconList->sDescr = (char *) calloc(sizeof(char), DescrLen + 1);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void FreeIconList(LPDBGICONLIST lpMyIconList)
{
    free(lpMyIconList->sExt);
    free(lpMyIconList->sDescr);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool GetIconForExt(char *inExt, char *outIconFile, int iMaxSz, int *outIconIndex, char *outDescr)
{
    char lsKey[256];
    char lsDefaultIcon[256];
    char lsTempKey[256];
    char Temp[256];
    DWORD dwBufferLen = 256;

    memset(lsKey, 0, sizeof(lsKey));
    memset(lsTempKey, 0, sizeof(lsTempKey));
    memset(lsDefaultIcon, 0, sizeof(lsDefaultIcon));

    dwBufferLen = 256;
    if(!Get_StringRegistryValue(HKEY_CLASSES_ROOT, inExt, NULL, lsKey, dwBufferLen))
        return false;

    dwBufferLen = 256;
    if(!Get_StringRegistryValue(HKEY_CLASSES_ROOT, lsKey, NULL, outDescr, dwBufferLen))
        return false;

    dwBufferLen = 256;
    sprintf_s(lsTempKey, sizeof(lsTempKey), "%s\\DefaultIcon", lsKey);
    if(!Get_StringRegistryValue(HKEY_CLASSES_ROOT, lsTempKey, NULL, lsDefaultIcon, dwBufferLen))
        return false;

    int iRPos = strlen(lsDefaultIcon) - 1;
    int iWPos = 0;

    while(iRPos > 1)
    {
        if(lsDefaultIcon[iRPos] != ' ' && lsDefaultIcon[iRPos] != '\t')
        {
            if(lsDefaultIcon[iRPos] == ',')
            {
                lsDefaultIcon[iRPos] = '\0';
                break;
            }

            if(!(lsDefaultIcon[iRPos] >= '0' && lsDefaultIcon[iRPos] <= '9') && lsDefaultIcon[iRPos] != '-')
            {
                break;
            }

            Temp[iWPos] = lsDefaultIcon[iRPos];
            iWPos++;
        }

        iRPos--;
    }

    if(iWPos > 0)
    {
        ReverseString(Temp, iWPos);
        *outIconIndex = atoi(Temp);
    }

    strcpy_s(outIconFile, iMaxSz, lsDefaultIcon);

    return true;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//This function will wait for the window specified by hWnd to become visible,
//	it will then set the window to the foreground and return.
bool WaitOnWindow(HWND hWnd)
{
    while(!IsWindowVisible(hWnd))
    {
        Sleep(1);
    }

    if(IsWindow(hWnd))
    {
        SetForegroundWindow(hWnd);
		return true;
    }

	return false;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//This function replaces all ForwardSlashes with BackSlashs and removes duplicates.
void CorrectReversePath(char *sPath)
{
	char sAltPath[MAX_PATH];

	ReplaceStrings(sPath, "/", "\\", sAltPath);
	
	while(ReplaceStrings(sAltPath, "\\\\", "\\", sPath))
	{
		strcpy_s(sAltPath, sizeof(sAltPath), sPath);
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//This function replaces all BackSlashs with ForwardSlashes and removes duplicates.
void CorrectForwardPath(char *sPath)
{
	char sAltPath[MAX_PATH];

	ReplaceStrings(sPath, "\\", "/", sAltPath);
	
	while(ReplaceStrings(sAltPath, "//", "/", sPath))
	{
		strcpy_s(sAltPath, sizeof(sAltPath), sPath);
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

double fFormattedValue(const char *sFormatted)
{
    int iLength = strlen(sFormatted);
    int iRPos = 0;
    int iWPos = 0;

    char sVal[32];

	while(iRPos < iLength)
    {
        if(sFormatted[iRPos] == ',')
            iRPos++;

        if((sFormatted[iRPos] < 48 || sFormatted[iRPos] > 57) && sFormatted[iRPos] != '.')
            break;

        sVal[iWPos] = sFormatted[iRPos];
        iRPos++;
        iWPos++;
    }
    sVal[iWPos] = '\0';

    return atof(sVal);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int iFormattedValue(const char *sFormatted)
{
    int iLength = strlen(sFormatted);
    int iRPos = 0;
    int iWPos = 0;

    char sVal[32];

    if(iLength <= 3)
    {
        return atol(sFormatted);
    }

	while(iRPos < iLength)
    {
        if(sFormatted[iRPos] == ',')
            iRPos++;

        if(sFormatted[iRPos] < 48 || sFormatted[iRPos] > 57)
            break;

        sVal[iWPos] = sFormatted[iRPos];
        iRPos++;
        iWPos++;
    }
    sVal[iWPos] = '\0';

    return atol(sVal);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif

