#ifndef _ENTRY_CPP
#define _ENTRY_CPP
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <ShlObj.H>
#include <Stdio.H>
#include <Stdlib.H>

#include "../Resources/Resource.H"

#include "NSWFL.H"
#include "Entry.H"
#include "Package.H"
#include "Init.H"
#include "CCmdLine.H"
#include "Console.H"

#include "../Dialogs/MainDlg.H"
#include "../Dialogs/OpenPassDlg.H"
#include "../Dialogs/NewPassDlg.H"
#include "../Dialogs/ReadingDlg.H"
#include "../Dialogs/ExtractDlg.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

HINSTANCE ghAppInstance = NULL;

char gsAppCopyRight[64];
char gsFileVersion[32];
char gsTitleCaption[64];
char gsRegistryKey[1024];
char gsWorkingOutput[MAX_PATH + 1];
char gsLastExtractLocation[MAX_PATH + 1];
char gsArchiveName[MAX_PATH + 1];
char gsPassword[1024 + 1];

DWORD gdwCurrentJobType = 0;

bool gbAutoClose = false;
bool gbArchiveOpen = false;

int giPkgAttribs = ATTRIB_DATETIME | ATTRIB_CRCCHECK | ATTRIB_SAVEPATHS |
						ATTRIB_ATTRIBUTES | ATTRIB_COMPRESSION;

int giCompressLevel = 0;
int giCryptAlgo = 0;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int ParseCmdLine(CCmdLine *lpCmd);

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevious, LPSTR CmdLine, int CmdShow)
{
	CCmdLine MyCmd;

	ghAppInstance = hInstance;

	if(!InitializeApp())
    {
        return 1;
    }

	if(MyCmd.Alloc())
	{
		ParseCmdLine(&MyCmd);

		DWORD ExitCode;
		while(GetExitCodeThread(hWorker_Thread_Handle, &ExitCode))
		{
			if(ExitCode != STILL_ACTIVE)
			{
				break;
			}
			else Sleep(100);
		}

	}

	MyCmd.Free();

	if(!UninitializeApp())
    {
        return 1;
    }

	return 0;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int ParseCmdLine(CCmdLine *lpCmd)
{
	int iArg = 0;
	int iArgSz = 0;
	char *sArg = NULL;
	char *sMsg = NULL;

	char sSource[MAX_PATH];
	char sTemp[255];

	bool bEncrypt = false;
	bool bDecrypt = false;
	bool bAuto = false;
	bool bSilent = false;
	bool bView = false;

	if(lpCmd->iCount == 1)
	{
	    // Create new archive
		DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, MainDialog);
		return 0;
	}

	while(iArg < lpCmd->iCount)
	{
		sArg = "/CompressLevel:";
		iArgSz = strlen(sArg);
		if(_strnicmp(lpCmd->sArray[iArg], sArg, iArgSz) == 0)
		{
			GetFlagedValue(lpCmd->sArray[iArg], iArgSz, lpCmd->iLen[iArg], sTemp);
			giCompressLevel = (atol(sTemp) - 1);
		}

		sArg = "/Auto";
		iArgSz = strlen(sArg);
		if(_strnicmp(lpCmd->sArray[iArg], sArg, iArgSz) == 0)
		{
			//bAuto = true;
		}

		sArg = "/New";
		iArgSz = strlen(sArg);
		if(_strnicmp(lpCmd->sArray[iArg], sArg, iArgSz) == 0)
		{
	        // Create new archive
			DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, MainDialog);
			return 0;
		}

		sArg = "/Source:";
		iArgSz = strlen(sArg);
		if(_strnicmp(lpCmd->sArray[iArg], sArg, iArgSz) == 0)
		{
			GetFlagedValue(lpCmd->sArray[iArg], iArgSz, lpCmd->iLen[iArg], sSource);
			strcpy_s(gsArchiveName, sizeof(gsArchiveName), sSource);
			//MsgBox(gsArchiveName);
		}

		sArg = "/Target:";
		iArgSz = strlen(sArg);
		if(_strnicmp(lpCmd->sArray[iArg], sArg, iArgSz) == 0)
		{
			GetFlagedValue(lpCmd->sArray[iArg], iArgSz, lpCmd->iLen[iArg], gsWorkingOutput);
			strcpy_s(gsExtractLocation, sizeof(gsExtractLocation), gsWorkingOutput);
			//MsgBox(gsWorkingOutput);
		}

		sArg = "/Encrypt";
		iArgSz = strlen(sArg);
		if(_strnicmp(lpCmd->sArray[iArg], sArg, iArgSz) == 0)
		{
			bEncrypt = true;
		}

		sArg = "/Decrypt";
		iArgSz = strlen(sArg);
		if(_strnicmp(lpCmd->sArray[iArg], sArg, iArgSz) == 0)
		{
			bDecrypt = true;
		}

		sArg = "/View";
		iArgSz = strlen(sArg);
		if(_strnicmp(lpCmd->sArray[iArg], sArg, iArgSz) == 0)
		{
			bView = true;
		}

		sArg = "/Silent";
		iArgSz = strlen(sArg);
		if(_strnicmp(lpCmd->sArray[iArg], sArg, iArgSz) == 0)
		{
			bSilent = true;
		}

		sArg = "/Password";
		iArgSz = strlen(sArg);
		if(_strnicmp(lpCmd->sArray[iArg], sArg, iArgSz) == 0)
		{
			GetFlagedValue(lpCmd->sArray[iArg], iArgSz, lpCmd->iLen[iArg], gsPassword);
		}

		sArg = "/AutoClose";
		iArgSz = strlen(sArg);
		if(_strnicmp(lpCmd->sArray[iArg], sArg, iArgSz) == 0)
		{
			gbAutoClose = true;
		}

		iArg++;
	}

	/*
	if(gbAutoClose || bAuto)
	{
		if(strlen(gsPassword) == 0 || strlen(sSource) == 0 || strlen(gsWorkingOutput) == 0)
		{
			sMsg = "If either the \"/AutoClose\" or \"/Auto\" parameters are specified, "
				"you must also specifiy:\r\n"
				"\tSource: (by using the \"/Source:\" parameter)\r\n"
				"\tTarget: (by using the \"/Target:\" parameter)\r\n"
				"\tPassword: (by using the \"/Password:\" parameter)\r\n\r\n"
				"Example:\r\n\tProjEps.exe /Source:\"C:\\My Folder\" /Target:\"C:\\NewFile.pce\" /Auto /AutoClose";
			MessageBox(NULL, sMsg, gsTitleCaption, NULL);
			return 1;
		}

	}
	*/

	if((bDecrypt == false && bEncrypt == false) || bView == true)
	{
        // View an existing archive
        gdwCurrentJobType = JOB_TYPE_READING;
        if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_OPENPASS), NULL, OpenPassDialog) != 1)
        {
            return 0;
        }
        hWorker_Thread_Handle = CreateThread(NULL, 0, ViewExisting_Worker_Thread, (LPVOID) sSource, CREATE_SUSPENDED, &dwWorker_Thread_ID);
        DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, MainDialog);

		return 0;
	}

	if(bDecrypt == true)
    {
        // Decrypt the entire archive.
		gdwCurrentJobType = JOB_TYPE_EXTRACTALL;
        if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_OPENPASS), NULL, OpenPassDialog) != 1)
        {
            return 0;
        }
        //hWorker_Thread_Handle = CreateThread(NULL, 0, ViewExisting_Worker_Thread, (LPVOID) sSource, CREATE_SUSPENDED, &dwWorker_Thread_ID);
        DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, MainDialog);

		return 0;
    }
    
    if(bEncrypt == true)
	{
		if(IsDirectory(sSource))
		{
			// Create a new archive from the directorys contents.

			gdwCurrentJobType = JOB_TYPE_PACKING_DIR;
			if(bAuto == false)
			{
				if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_NEWPASS), NULL, NewPassDialog) != 1)
				{
					return 0;
				}
			}
			hWorker_Thread_Handle = CreateThread(NULL, 0, CreateNewDirArchive_Worker_Thread, (LPVOID) sSource, CREATE_SUSPENDED, &dwWorker_Thread_ID);
			DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, MainDialog);
		}
		else{
			// Create a new archive containing a single file.
			FilePack MyFilePack;

			MyFilePack.Initialize(&AltFilePackage);
			
			//This is alot of memory, but we need it all.
			char sFileName[MAX_PATH]; 
			char sDirTemp[MAX_PATH]; //Just some memory for AddFile() to use.
			char sRoot[MAX_PATH + 1];
			char sDrive[MAX_PATH + 1];
			char sDir[MAX_PATH + 1];
			char sFile[MAX_PATH + 1];
			char sExt[MAX_PATH + 1];

			int iRootLen = 0;

			_splitpath_s(sSource,
				sDrive, sizeof(sDrive),
				sDir, sizeof(sDir),
				sFile, sizeof(sFile),
				sExt, sizeof(sExt));

			_makepath_s(sRoot, sizeof(sRoot), sDrive, sDir, NULL, NULL);
			_makepath_s(sFileName, sizeof(sFileName), NULL, NULL, sFile, sExt);

			iRootLen = strlen(sRoot);

			MyFilePack.AddFile(sRoot, iRootLen, sDirTemp, iRootLen, sFileName, &AltFilePackage);

			gdwCurrentJobType = JOB_TYPE_PACKING_FIL;
			if(bAuto == false)
			{
				if(DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_NEWPASS), NULL, NewPassDialog) != 1)
				{
					return 0;
				}
			}
			hWorker_Thread_Handle = CreateThread(NULL, 0, CreateFileArchive_Worker_Thread, (LPVOID) sRoot, CREATE_SUSPENDED, &dwWorker_Thread_ID);
			DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, MainDialog);
		}

		return 0;
	}

	return 0;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
